/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v1.0
processor: MK64FN1M0xxx12
package_id: MK64FN1M0VMD12
mcu_data: ksdk2_0
processor_version: 3.0.1
functionalGroups:
- name: BOARD_Init_BRIDGE_UART
  description: Enable Bridge UART between KW41Z and K64F
  selectedCore: core0
- name: BOARD_Init_BATSENS
  description: Enable ADC used to sense VBat
  selectedCore: core0
- name: BOARD_Init_TERMINAL_UART
  description: Enable Debug UART
  selectedCore: core0
- name: BOARD_Init_BUZZER
  description: 'Init Flextimer (PWM) used for the buzzer: 4kHz / 50% duty cycle'
  selectedCore: core0
- name: BOARD_Init_RGB_BLIGHT
  description: Init Flextimer (PWM) used for RGB LEDs
  selectedCore: core0
- name: BOARD_Init_RTC_SPI
  description: SPI dedicated for RTC (PCF2123)
  selectedCore: core0
- name: BOARD_Init_SPI_2
  description: "SPI dedicated to External Flash.\r\n\r\n!!! KW41Z also connected to this SPI <=> shared External Flash"
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system_54b53072540eeeb8f8e9343e71f28176'
- global_system_definitions: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_Init_BRIDGE_UART functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * BRIDGE_UART initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'BRIDGE_UART'
- type: 'uart'
- mode: 'interrupts'
- type_id: 'uart_cd31a12aa8c79051fda42cc851a27c37'
- functional_group: 'BOARD_Init_BRIDGE_UART'
- peripheral: 'UART4'
- config_sets:
  - uartConfig_t:
    - uartConfig:
      - baudRate_Bps: '115200'
      - parityMode: 'kUART_ParityDisabled'
      - stopBitCount: 'kUART_OneStopBit'
      - txFifoWatermark: '0'
      - rxFifoWatermark: '1'
      - idleType: 'kUART_IdleTypeStartBit'
      - enableTx: 'true'
      - enableRx: 'true'
  - interruptsCfg:
    - interrupts: 'kUART_RxDataRegFullInterruptEnable kUART_RxOverrunInterruptEnable'
    - interrupt_vectors:
      - enable_rx_tx_irq: 'true'
      - interrupt_rx_tx:
        - IRQn: 'UART4_RX_TX_IRQn'
        - enable_priority: 'true'
        - priority: '5'
        - enable_custom_name: 'false'
      - enable_err_irq: 'false'
      - interrupt_err:
        - IRQn: 'UART4_ERR_IRQn'
        - enable_priority: 'false'
        - enable_custom_name: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const uart_config_t BRIDGE_UART_config = {
  .baudRate_Bps = 115200,
  .parityMode = kUART_ParityDisabled,
  .stopBitCount = kUART_OneStopBit,
  .txFifoWatermark = 0,
  .rxFifoWatermark = 1,
  .idleType = kUART_IdleTypeStartBit,
  .enableTx = true,
  .enableRx = true
};

void BRIDGE_UART_init(void) {
  UART_Init(BRIDGE_UART_PERIPHERAL, &BRIDGE_UART_config, BRIDGE_UART_CLOCK_SOURCE);
  UART_EnableInterrupts(BRIDGE_UART_PERIPHERAL, kUART_RxDataRegFullInterruptEnable | kUART_RxOverrunInterruptEnable);
  /* Interrupt vector UART4_RX_TX_IRQn priority settings in the NVIC */
  NVIC_SetPriority(BRIDGE_UART_SERIAL_RX_TX_IRQN, BRIDGE_UART_SERIAL_RX_TX_IRQ_PRIORITY);
  /* Enable interrupt UART4_RX_TX_IRQn request in the NVIC */
  EnableIRQ(BRIDGE_UART_SERIAL_RX_TX_IRQN);
}

/***********************************************************************************************************************
 * BOARD_Init_BATSENS functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * BATSENS initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'BATSENS'
- type: 'adc16'
- mode: 'ADC'
- type_id: 'adc16_7d827be2dc433dc756d94a7ce88cbcc5'
- functional_group: 'BOARD_Init_BATSENS'
- peripheral: 'ADC0'
- config_sets:
  - fsl_adc16:
    - adc16_config:
      - referenceVoltageSource: 'kADC16_ReferenceVoltageSourceValt'
      - clockSource: 'kADC16_ClockSourceAlt3'
      - enableAsynchronousClock: 'true'
      - clockDivider: 'kADC16_ClockDivider8'
      - resolution: 'kADC16_Resolution12or13Bit'
      - longSampleMode: 'kADC16_LongSampleDisabled'
      - enableHighSpeed: 'false'
      - enableLowPower: 'false'
      - enableContinuousConversion: 'false'
    - adc16_channel_mux_mode: 'kADC16_ChannelMuxA'
    - adc16_hardware_compare_config:
      - hardwareCompareModeEnable: 'false'
    - doAutoCalibration: 'true'
    - trigger: 'false'
    - hardwareAverageConfiguration: 'kADC16_HardwareAverageCount32'
    - enable_irq: 'false'
    - adc_interrupt:
      - IRQn: 'ADC0_IRQn'
      - enable_priority: 'false'
      - enable_custom_name: 'false'
    - adc16_channels_config:
      - 0:
        - enableDifferentialConversion: 'false'
        - channelNumber: 'SE.21'
        - enableInterruptOnConversionCompleted: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
adc16_channel_config_t BATSENS_channelsConfig[1] = {
  {
    .channelNumber = 21U,
    .enableDifferentialConversion = false,
    .enableInterruptOnConversionCompleted = false
  }
};
const adc16_config_t BATSENS_config = {
  .referenceVoltageSource = kADC16_ReferenceVoltageSourceValt,
  .clockSource = kADC16_ClockSourceAlt3,
  .enableAsynchronousClock = true,
  .clockDivider = kADC16_ClockDivider8,
  .resolution = kADC16_Resolution12or13Bit,
  .longSampleMode = kADC16_LongSampleDisabled,
  .enableHighSpeed = false,
  .enableLowPower = false,
  .enableContinuousConversion = false
};
const adc16_channel_mux_mode_t BATSENS_muxMode = kADC16_ChannelMuxA;
const adc16_hardware_average_mode_t BATSENS_hardwareAverageMode = kADC16_HardwareAverageCount32;

void BATSENS_init(void) {
  /* Initialize ADC16 converter */
  ADC16_Init(BATSENS_PERIPHERAL, &BATSENS_config);
  /* Make sure, that software trigger is used */
  ADC16_EnableHardwareTrigger(BATSENS_PERIPHERAL, false);
  /* Configure hardware average mode */
  ADC16_SetHardwareAverage(BATSENS_PERIPHERAL, BATSENS_hardwareAverageMode);
  /* Configure channel multiplexing mode */
  ADC16_SetChannelMuxMode(BATSENS_PERIPHERAL, BATSENS_muxMode);
  /* Perform auto calibration */
  ADC16_DoAutoCalibration(BATSENS_PERIPHERAL);
}

/***********************************************************************************************************************
 * BOARD_Init_TERMINAL_UART functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * TERMINAL_UART initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'TERMINAL_UART'
- type: 'uart'
- mode: 'polling'
- type_id: 'uart_cd31a12aa8c79051fda42cc851a27c37'
- functional_group: 'BOARD_Init_TERMINAL_UART'
- peripheral: 'UART0'
- config_sets:
  - uartConfig_t:
    - uartConfig:
      - baudRate_Bps: '115200'
      - parityMode: 'kUART_ParityDisabled'
      - stopBitCount: 'kUART_OneStopBit'
      - txFifoWatermark: '0'
      - rxFifoWatermark: '1'
      - idleType: 'kUART_IdleTypeStartBit'
      - enableTx: 'true'
      - enableRx: 'true'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const uart_config_t TERMINAL_UART_config = {
  .baudRate_Bps = 115200,
  .parityMode = kUART_ParityDisabled,
  .stopBitCount = kUART_OneStopBit,
  .txFifoWatermark = 0,
  .rxFifoWatermark = 1,
  .idleType = kUART_IdleTypeStartBit,
  .enableTx = true,
  .enableRx = true
};

void TERMINAL_UART_init(void) {
  UART_Init(TERMINAL_UART_PERIPHERAL, &TERMINAL_UART_config, TERMINAL_UART_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * BOARD_Init_BUZZER functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * BUZZER initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'BUZZER'
- type: 'ftm'
- mode: 'CenterAligned'
- type_id: 'ftm_5e037045c21cf6f361184c371dbbbab2'
- functional_group: 'BOARD_Init_BUZZER'
- peripheral: 'FTM1'
- config_sets:
  - ftm_main_config:
    - ftm_config:
      - clockSource: 'kFTM_SystemClock'
      - prescale: 'kFTM_Prescale_Divide_4'
      - timerFrequency: '4000'
      - bdmMode: 'kFTM_BdmMode_0'
      - pwmSyncMode: 'kFTM_SoftwareTrigger'
      - reloadPoints: ''
      - faultMode: 'kFTM_Fault_Disable'
      - faultFilterValue: '0'
      - deadTimePrescale: 'kFTM_Deadtime_Prescale_1'
      - deadTimeValue: '0'
      - extTriggers: ''
      - chnlInitState: ''
      - chnlPolarity: ''
      - useGlobalTimeBase: 'false'
    - timer_interrupts: ''
    - enable_irq: 'false'
    - ftm_interrupt:
      - IRQn: 'FTM1_IRQn'
      - enable_priority: 'false'
      - enable_custom_name: 'false'
    - EnableTimerInInit: 'false'
  - ftm_center_aligned_mode:
    - ftm_center_aligned_channels_config:
      - 0:
        - chnlNumber: 'kFTM_Chnl_0'
        - level: 'kFTM_LowTrue'
        - dutyCyclePercent: '50'
        - enable_chan_irq: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const ftm_config_t BUZZER_config = {
  .prescale = kFTM_Prescale_Divide_4,
  .bdmMode = kFTM_BdmMode_0,
  .pwmSyncMode = kFTM_SoftwareTrigger,
  .reloadPoints = 0,
  .faultMode = kFTM_Fault_Disable,
  .faultFilterValue = 0,
  .deadTimePrescale = kFTM_Deadtime_Prescale_1,
  .deadTimeValue = 0,
  .extTriggers = 0,
  .chnlInitState = 0,
  .chnlPolarity = 0,
  .useGlobalTimeBase = false
};
const ftm_chnl_pwm_signal_param_t BUZZER_centerPwmSignalParams[] = { 
  {
    .chnlNumber = kFTM_Chnl_0,
    .level = kFTM_LowTrue,
    .dutyCyclePercent = 50
  }
};

void BUZZER_init(void) {
  FTM_Init(BUZZER_PERIPHERAL, &BUZZER_config);
  FTM_SetupPwm(BUZZER_PERIPHERAL, BUZZER_centerPwmSignalParams, sizeof(BUZZER_centerPwmSignalParams) / sizeof(ftm_chnl_pwm_signal_param_t), kFTM_CenterAlignedPwm, 4000U, BUZZER_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * BOARD_Init_RGB_BLIGHT functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * RGB_BLIGHT initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'RGB_BLIGHT'
- type: 'ftm'
- mode: 'CenterAligned'
- type_id: 'ftm_5e037045c21cf6f361184c371dbbbab2'
- functional_group: 'BOARD_Init_RGB_BLIGHT'
- peripheral: 'FTM3'
- config_sets:
  - ftm_main_config:
    - ftm_config:
      - clockSource: 'kFTM_SystemClock'
      - prescale: 'kFTM_Prescale_Divide_128'
      - timerFrequency: '100'
      - bdmMode: 'kFTM_BdmMode_0'
      - pwmSyncMode: 'kFTM_SoftwareTrigger'
      - reloadPoints: ''
      - faultMode: 'kFTM_Fault_Disable'
      - faultFilterValue: '0'
      - deadTimePrescale: 'kFTM_Deadtime_Prescale_1'
      - deadTimeValue: '0'
      - extTriggers: ''
      - chnlInitState: ''
      - chnlPolarity: ''
      - useGlobalTimeBase: 'false'
    - timer_interrupts: ''
    - enable_irq: 'false'
    - ftm_interrupt:
      - IRQn: 'FTM3_IRQn'
      - enable_priority: 'false'
      - enable_custom_name: 'false'
    - EnableTimerInInit: 'false'
  - ftm_center_aligned_mode:
    - ftm_center_aligned_channels_config:
      - 0:
        - chnlNumber: 'kFTM_Chnl_1'
        - level: 'kFTM_LowTrue'
        - dutyCyclePercent: '50'
        - enable_chan_irq: 'false'
      - 1:
        - chnlNumber: 'kFTM_Chnl_2'
        - level: 'kFTM_LowTrue'
        - dutyCyclePercent: '0'
        - enable_chan_irq: 'false'
      - 2:
        - chnlNumber: 'kFTM_Chnl_4'
        - level: 'kFTM_LowTrue'
        - dutyCyclePercent: '0'
        - enable_chan_irq: 'false'
      - 3:
        - chnlNumber: 'kFTM_Chnl_5'
        - level: 'kFTM_LowTrue'
        - dutyCyclePercent: '0'
        - enable_chan_irq: 'false'
      - 4:
        - chnlNumber: 'kFTM_Chnl_7'
        - level: 'kFTM_HighTrue'
        - dutyCyclePercent: '0'
        - enable_chan_irq: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const ftm_config_t RGB_BLIGHT_config = {
  .prescale = kFTM_Prescale_Divide_128,
  .bdmMode = kFTM_BdmMode_0,
  .pwmSyncMode = kFTM_SoftwareTrigger,
  .reloadPoints = 0,
  .faultMode = kFTM_Fault_Disable,
  .faultFilterValue = 0,
  .deadTimePrescale = kFTM_Deadtime_Prescale_1,
  .deadTimeValue = 0,
  .extTriggers = 0,
  .chnlInitState = 0,
  .chnlPolarity = 0,
  .useGlobalTimeBase = false
};
const ftm_chnl_pwm_signal_param_t RGB_BLIGHT_centerPwmSignalParams[] = { 
  {
    .chnlNumber = kFTM_Chnl_1, /* DISP_EXTCOMIN 100 Hz signal */
    .level = kFTM_LowTrue,
    .dutyCyclePercent = 50
  },
  {
    .chnlNumber = kFTM_Chnl_2,
    .level = kFTM_LowTrue,
    .dutyCyclePercent = 0
  },
  {
    .chnlNumber = kFTM_Chnl_4,
    .level = kFTM_LowTrue,
    .dutyCyclePercent = 0
  },
  {
    .chnlNumber = kFTM_Chnl_5,
    .level = kFTM_LowTrue,
    .dutyCyclePercent = 0
  },
  {
    .chnlNumber = kFTM_Chnl_7,
    .level = kFTM_HighTrue,
    .dutyCyclePercent = 0
  }
};

void RGB_BLIGHT_init(void) {
  FTM_Init(RGB_BLIGHT_PERIPHERAL, &RGB_BLIGHT_config);
  FTM_SetupPwm(RGB_BLIGHT_PERIPHERAL, RGB_BLIGHT_centerPwmSignalParams, sizeof(RGB_BLIGHT_centerPwmSignalParams) / sizeof(ftm_chnl_pwm_signal_param_t), kFTM_CenterAlignedPwm, 100U, RGB_BLIGHT_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * BOARD_Init_RTC_SPI functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * RTC_SPI initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'RTC_SPI'
- type: 'dspi'
- mode: 'DSPI_Transfer'
- type_id: 'dspi_305e5b03c593d065f61ded8061d15797'
- functional_group: 'BOARD_Init_RTC_SPI'
- peripheral: 'SPI1'
- config_sets:
  - fsl_dspi:
    - dspi_mode: 'kDSPI_Master'
    - dspi_master_config:
      - whichCtar: 'kDSPI_Ctar0'
      - ctarConfig:
        - baudRate: '2000000'
        - bitsPerFrame: '8'
        - cpol: 'kDSPI_ClockPolarityActiveHigh'
        - cpha: 'kDSPI_ClockPhaseFirstEdge'
        - direction: 'kDSPI_MsbFirst'
        - pcsToSckDelayInNanoSec: '1000'
        - lastSckToPcsDelayInNanoSec: '1000'
        - betweenTransferDelayInNanoSec: '1000'
      - whichPcs: 'PCS1'
      - pcsActiveHighOrLow: 'kDSPI_PcsActiveHigh'
      - enableContinuousSCK: 'false'
      - enableRxFifoOverWrite: 'false'
      - enableModifiedTimingFormat: 'false'
      - samplePoint: 'kDSPI_SckToSin0Clock'
  - transferCfg:
    - transfer:
      - init_transfer: 'false'
      - transfer_cfg:
        - halfDuplex: 'false'
        - txDataBufferEnable: 'true'
        - rxDataBufferEnable: 'true'
        - dataSize: '10'
      - init_callback: 'false'
      - callback_fcn: ''
      - user_data: ''
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const dspi_master_config_t RTC_SPI_config = {
  .whichCtar = kDSPI_Ctar0,
  .ctarConfig = {
    .baudRate = 2000000,
    .bitsPerFrame = 8,
    .cpol = kDSPI_ClockPolarityActiveHigh,
    .cpha = kDSPI_ClockPhaseFirstEdge,
    .direction = kDSPI_MsbFirst,
    .pcsToSckDelayInNanoSec = 1000,
    .lastSckToPcsDelayInNanoSec = 1000,
    .betweenTransferDelayInNanoSec = 1000
  },
  .whichPcs = kDSPI_Pcs1,
  .pcsActiveHighOrLow = kDSPI_PcsActiveHigh,
  .enableContinuousSCK = false,
  .enableRxFifoOverWrite = false,
  .enableModifiedTimingFormat = false,
  .samplePoint = kDSPI_SckToSin0Clock
};
dspi_master_handle_t RTC_SPI_handle;

void RTC_SPI_init(void) {
  /* Initialization function */
  DSPI_MasterInit(RTC_SPI_PERIPHERAL, &RTC_SPI_config, CLOCK_GetFreq(RTC_SPI_CLKSRC));
  DSPI_MasterTransferCreateHandle(RTC_SPI_PERIPHERAL, &RTC_SPI_handle, NULL, NULL);
}

/***********************************************************************************************************************
 * BOARD_Init_SPI_2 functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * DSPI_2 initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'DSPI_2'
- type: 'dspi'
- mode: 'DSPI_Transfer'
- type_id: 'dspi_305e5b03c593d065f61ded8061d15797'
- functional_group: 'BOARD_Init_SPI_2'
- peripheral: 'SPI2'
- config_sets:
  - fsl_dspi:
    - dspi_mode: 'kDSPI_Master'
    - dspi_master_config:
      - whichCtar: 'kDSPI_Ctar0'
      - ctarConfig:
        - baudRate: '1000000'
        - bitsPerFrame: '8'
        - cpol: 'kDSPI_ClockPolarityActiveHigh'
        - cpha: 'kDSPI_ClockPhaseFirstEdge'
        - direction: 'kDSPI_MsbFirst'
        - pcsToSckDelayInNanoSec: '1000'
        - lastSckToPcsDelayInNanoSec: '1000'
        - betweenTransferDelayInNanoSec: '1000'
      - whichPcs: 'PCS0_SS'
      - pcsActiveHighOrLow: 'kDSPI_PcsActiveLow'
      - enableContinuousSCK: 'false'
      - enableRxFifoOverWrite: 'false'
      - enableModifiedTimingFormat: 'false'
      - samplePoint: 'kDSPI_SckToSin0Clock'
  - transferCfg:
    - transfer:
      - init_transfer: 'false'
      - transfer_cfg:
        - halfDuplex: 'false'
        - txDataBufferEnable: 'true'
        - rxDataBufferEnable: 'true'
        - dataSize: '10'
      - init_callback: 'false'
      - callback_fcn: ''
      - user_data: ''
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const dspi_master_config_t DSPI_2_config = {
  .whichCtar = kDSPI_Ctar0,
  .ctarConfig = {
    .baudRate = 1000000,
    .bitsPerFrame = 8,
    .cpol = kDSPI_ClockPolarityActiveHigh,
    .cpha = kDSPI_ClockPhaseFirstEdge,
    .direction = kDSPI_MsbFirst,
    .pcsToSckDelayInNanoSec = 1000,
    .lastSckToPcsDelayInNanoSec = 1000,
    .betweenTransferDelayInNanoSec = 1000
  },
  .whichPcs = kDSPI_Pcs0,
  .pcsActiveHighOrLow = kDSPI_PcsActiveLow,
  .enableContinuousSCK = false,
  .enableRxFifoOverWrite = false,
  .enableModifiedTimingFormat = false,
  .samplePoint = kDSPI_SckToSin0Clock
};
dspi_master_handle_t DSPI_2_handle;

void DSPI_2_init(void) {
  /* Initialization function */
  DSPI_MasterInit(DSPI_2_PERIPHERAL, &DSPI_2_config, CLOCK_GetFreq(DSPI_2_CLKSRC));
  DSPI_MasterTransferCreateHandle(DSPI_2_PERIPHERAL, &DSPI_2_handle, NULL, NULL);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_Init_BRIDGE_UART(void)
{
  /* Initialize components */
  BRIDGE_UART_init();
}

void BOARD_Init_BATSENS(void)
{
  /* Initialize components */
  BATSENS_init();
}

void BOARD_Init_TERMINAL_UART(void)
{
  /* Initialize components */
  TERMINAL_UART_init();
}

void BOARD_Init_BUZZER(void)
{
  /* Initialize components */
  BUZZER_init();
}

void BOARD_Init_RGB_BLIGHT(void)
{
  /* Initialize components */
  RGB_BLIGHT_init();
}

void BOARD_Init_RTC_SPI(void)
{
  /* Initialize components */
  RTC_SPI_init();
}

void BOARD_Init_SPI_2(void)
{
  /* Initialize components */
  DSPI_2_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
}
