#include "atmosphere_abilityHandler.h"
#include "atmosphere_triggerHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value) {
	switch(abilityHandleId) {
		case ATMO_ABILITY(getHPa, trigger):
		{
			ATMO_Value_t getHPa_Value;
			ATMO_InitValue(&getHPa_Value);
			getHPa_trigger(value, &getHPa_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(getHPa, triggered), &getHPa_Value);
			ATMO_FreeValue(&getHPa_Value);
			break;
		}
		case ATMO_ABILITY(FastInterval, trigger):
		{
			ATMO_Value_t FastInterval_Value;
			ATMO_InitValue(&FastInterval_Value);
			FastInterval_trigger(value, &FastInterval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FastInterval, triggered), &FastInterval_Value);
			ATMO_FreeValue(&FastInterval_Value);
			break;
		}
		case ATMO_ABILITY(FastInterval, setup):
		{
			ATMO_Value_t FastInterval_Value;
			ATMO_InitValue(&FastInterval_Value);
			FastInterval_setup(value, &FastInterval_Value);
			ATMO_FreeValue(&FastInterval_Value);
			break;
		}
		case ATMO_ABILITY(FastInterval, interval):
		{
			ATMO_Value_t FastInterval_Value;
			ATMO_InitValue(&FastInterval_Value);
			FastInterval_interval(value, &FastInterval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(FastInterval, interval), &FastInterval_Value);
			ATMO_FreeValue(&FastInterval_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, trigger):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_trigger(value, &TempChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TempChar, triggered), &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, setup):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_setup(value, &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, setValue):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_setValue(value, &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, written):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_written(value, &TempChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TempChar, written), &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, subscibed):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_subscibed(value, &TempChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TempChar, subscibed), &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(TempChar, unsubscribed):
		{
			ATMO_Value_t TempChar_Value;
			ATMO_InitValue(&TempChar_Value);
			TempChar_unsubscribed(value, &TempChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TempChar, unsubscribed), &TempChar_Value);
			ATMO_FreeValue(&TempChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, trigger):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_trigger(value, &HumidChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(HumidChar, triggered), &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, setup):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_setup(value, &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, setValue):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_setValue(value, &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, written):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_written(value, &HumidChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(HumidChar, written), &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, subscibed):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_subscibed(value, &HumidChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(HumidChar, subscibed), &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(HumidChar, unsubscribed):
		{
			ATMO_Value_t HumidChar_Value;
			ATMO_InitValue(&HumidChar_Value);
			HumidChar_unsubscribed(value, &HumidChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(HumidChar, unsubscribed), &HumidChar_Value);
			ATMO_FreeValue(&HumidChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, trigger):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_trigger(value, &LightChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(LightChar, triggered), &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, setup):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_setup(value, &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, setValue):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_setValue(value, &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, written):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_written(value, &LightChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(LightChar, written), &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, subscibed):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_subscibed(value, &LightChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(LightChar, subscibed), &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(LightChar, unsubscribed):
		{
			ATMO_Value_t LightChar_Value;
			ATMO_InitValue(&LightChar_Value);
			LightChar_unsubscribed(value, &LightChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(LightChar, unsubscribed), &LightChar_Value);
			ATMO_FreeValue(&LightChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, trigger):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_trigger(value, &PressureChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PressureChar, triggered), &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, setup):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_setup(value, &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, setValue):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_setValue(value, &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, written):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_written(value, &PressureChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PressureChar, written), &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, subscibed):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_subscibed(value, &PressureChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PressureChar, subscibed), &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(PressureChar, unsubscribed):
		{
			ATMO_Value_t PressureChar_Value;
			ATMO_InitValue(&PressureChar_Value);
			PressureChar_unsubscribed(value, &PressureChar_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PressureChar, unsubscribed), &PressureChar_Value);
			ATMO_FreeValue(&PressureChar_Value);
			break;
		}
		case ATMO_ABILITY(VOC, trigger):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_trigger(value, &VOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC, triggered), &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(VOC, setup):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_setup(value, &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(VOC, setValue):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_setValue(value, &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(VOC, written):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_written(value, &VOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC, written), &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(VOC, subscibed):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_subscibed(value, &VOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC, subscibed), &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(VOC, unsubscribed):
		{
			ATMO_Value_t VOC_Value;
			ATMO_InitValue(&VOC_Value);
			VOC_unsubscribed(value, &VOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC, unsubscribed), &VOC_Value);
			ATMO_FreeValue(&VOC_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, trigger):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_trigger(value, &MPL3115Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(MPL3115Pressure, triggered), &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, setup):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_setup(value, &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, setEnabled):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_setEnabled(value, &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, setDisabled):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_setDisabled(value, &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, setEnabledDisabled):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_setEnabledDisabled(value, &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, readAltitude):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_readAltitude(value, &MPL3115Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(MPL3115Pressure, altitudeRead), &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, readPressure):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_readPressure(value, &MPL3115Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(MPL3115Pressure, pressureRead), &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(MPL3115Pressure, readPressureKpa):
		{
			ATMO_Value_t MPL3115Pressure_Value;
			ATMO_InitValue(&MPL3115Pressure_Value);
			MPL3115Pressure_readPressureKpa(value, &MPL3115Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(MPL3115Pressure, pressureReadKpa), &MPL3115Pressure_Value);
			ATMO_FreeValue(&MPL3115Pressure_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, trigger):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_trigger(value, &TSL2572AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TSL2572AmbientLight, triggered), &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setup):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setup(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setEnabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setEnabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setDisabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setDisabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, setEnabledDisabled):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_setEnabledDisabled(value, &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(TSL2572AmbientLight, readAmbientLight):
		{
			ATMO_Value_t TSL2572AmbientLight_Value;
			ATMO_InitValue(&TSL2572AmbientLight_Value);
			TSL2572AmbientLight_readAmbientLight(value, &TSL2572AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(TSL2572AmbientLight, ambientLightRead), &TSL2572AmbientLight_Value);
			ATMO_FreeValue(&TSL2572AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, trigger):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_trigger(value, &CCS811AirQuality_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CCS811AirQuality, triggered), &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, setup):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_setup(value, &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, setEnabled):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_setEnabled(value, &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, setDisabled):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_setDisabled(value, &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, setEnabledDisabled):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_setEnabledDisabled(value, &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, readTVOC):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_readTVOC(value, &CCS811AirQuality_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CCS811AirQuality, TVOCRead), &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(CCS811AirQuality, readCO2):
		{
			ATMO_Value_t CCS811AirQuality_Value;
			ATMO_InitValue(&CCS811AirQuality_Value);
			CCS811AirQuality_readCO2(value, &CCS811AirQuality_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CCS811AirQuality, CO2Read), &CCS811AirQuality_Value);
			ATMO_FreeValue(&CCS811AirQuality_Value);
			break;
		}
		case ATMO_ABILITY(Apps, trigger):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_trigger(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, triggered), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, displayPage):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_displayPage(value, &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, onDisplayed):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_onDisplayed(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, onDisplayed), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, topRightButtonPressed):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_topRightButtonPressed(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, topRightButtonPressed), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, bottomRightButtonPressed):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_bottomRightButtonPressed(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, bottomRightButtonPressed), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, topLeftButtonPressed):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_topLeftButtonPressed(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, topLeftButtonPressed), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, bottomLeftButtonPressed):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_bottomLeftButtonPressed(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, bottomLeftButtonPressed), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, setup):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_setup(value, &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, onLeave):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_onLeave(value, &Apps_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Apps, onLeave), &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(Apps, setLabel):
		{
			ATMO_Value_t Apps_Value;
			ATMO_InitValue(&Apps_Value);
			Apps_setLabel(value, &Apps_Value);
			ATMO_FreeValue(&Apps_Value);
			break;
		}
		case ATMO_ABILITY(SlowInterval, trigger):
		{
			ATMO_Value_t SlowInterval_Value;
			ATMO_InitValue(&SlowInterval_Value);
			SlowInterval_trigger(value, &SlowInterval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SlowInterval, triggered), &SlowInterval_Value);
			ATMO_FreeValue(&SlowInterval_Value);
			break;
		}
		case ATMO_ABILITY(SlowInterval, setup):
		{
			ATMO_Value_t SlowInterval_Value;
			ATMO_InitValue(&SlowInterval_Value);
			SlowInterval_setup(value, &SlowInterval_Value);
			ATMO_FreeValue(&SlowInterval_Value);
			break;
		}
		case ATMO_ABILITY(SlowInterval, interval):
		{
			ATMO_Value_t SlowInterval_Value;
			ATMO_InitValue(&SlowInterval_Value);
			SlowInterval_interval(value, &SlowInterval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SlowInterval, interval), &SlowInterval_Value);
			ATMO_FreeValue(&SlowInterval_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedSystemStatusDisplay, trigger):
		{
			ATMO_Value_t EmbeddedSystemStatusDisplay_Value;
			ATMO_InitValue(&EmbeddedSystemStatusDisplay_Value);
			EmbeddedSystemStatusDisplay_trigger(value, &EmbeddedSystemStatusDisplay_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedSystemStatusDisplay, triggered), &EmbeddedSystemStatusDisplay_Value);
			ATMO_FreeValue(&EmbeddedSystemStatusDisplay_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedSystemStatusDisplay, displayPage):
		{
			ATMO_Value_t EmbeddedSystemStatusDisplay_Value;
			ATMO_InitValue(&EmbeddedSystemStatusDisplay_Value);
			EmbeddedSystemStatusDisplay_displayPage(value, &EmbeddedSystemStatusDisplay_Value);
			ATMO_FreeValue(&EmbeddedSystemStatusDisplay_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedSystemStatusDisplay, onDisplayed):
		{
			ATMO_Value_t EmbeddedSystemStatusDisplay_Value;
			ATMO_InitValue(&EmbeddedSystemStatusDisplay_Value);
			EmbeddedSystemStatusDisplay_onDisplayed(value, &EmbeddedSystemStatusDisplay_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedSystemStatusDisplay, onDisplayed), &EmbeddedSystemStatusDisplay_Value);
			ATMO_FreeValue(&EmbeddedSystemStatusDisplay_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedSystemStatusDisplay, setup):
		{
			ATMO_Value_t EmbeddedSystemStatusDisplay_Value;
			ATMO_InitValue(&EmbeddedSystemStatusDisplay_Value);
			EmbeddedSystemStatusDisplay_setup(value, &EmbeddedSystemStatusDisplay_Value);
			ATMO_FreeValue(&EmbeddedSystemStatusDisplay_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, trigger):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_trigger(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, triggered), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, setup):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_setup(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, topRightPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_topRightPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topRightPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, bottomRightPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_bottomRightPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomRightPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, topLeftPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_topLeftPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topLeftPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedNxpRpkUserButtons, bottomLeftPushed):
		{
			ATMO_Value_t EmbeddedNxpRpkUserButtons_Value;
			ATMO_InitValue(&EmbeddedNxpRpkUserButtons_Value);
			EmbeddedNxpRpkUserButtons_bottomLeftPushed(value, &EmbeddedNxpRpkUserButtons_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomLeftPushed), &EmbeddedNxpRpkUserButtons_Value);
			ATMO_FreeValue(&EmbeddedNxpRpkUserButtons_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, trigger):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_trigger(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, triggered), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, setup):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_setup(value, &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, getTouchData):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_getTouchData(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressUp):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressUp(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, upPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressDown):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressDown(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, downPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressLeft):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressLeft(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, leftPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(SX9500Touch, pressRight):
		{
			ATMO_Value_t SX9500Touch_Value;
			ATMO_InitValue(&SX9500Touch_Value);
			SX9500Touch_pressRight(value, &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, rightPressed), &SX9500Touch_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(SX9500Touch, touchDataRead), &SX9500Touch_Value);
			ATMO_FreeValue(&SX9500Touch_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, trigger):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_trigger(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, triggered), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, setup):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_setup(value, &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, displayRootPage):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_displayRootPage(value, &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateUp):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateUp(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateUp), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateDown):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateDown(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateDown), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateLeft):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateLeft(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateLeft), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, navigateRight):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_navigateRight(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, navigateRight), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processTopRightButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processTopRightButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processTopRightButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processBottomRightButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processBottomRightButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processBottomRightButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processTopLeftButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processTopLeftButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processTopLeftButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(EmbeddedPageController, processBottomLeftButton):
		{
			ATMO_Value_t EmbeddedPageController_Value;
			ATMO_InitValue(&EmbeddedPageController_Value);
			EmbeddedPageController_processBottomLeftButton(value, &EmbeddedPageController_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(EmbeddedPageController, processBottomLeftButton), &EmbeddedPageController_Value);
			ATMO_FreeValue(&EmbeddedPageController_Value);
			break;
		}
		case ATMO_ABILITY(GetTempStr, trigger):
		{
			ATMO_Value_t GetTempStr_Value;
			ATMO_InitValue(&GetTempStr_Value);
			GetTempStr_trigger(value, &GetTempStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetTempStr, triggered), &GetTempStr_Value);
			ATMO_FreeValue(&GetTempStr_Value);
			break;
		}
		case ATMO_ABILITY(GetLightStr, trigger):
		{
			ATMO_Value_t GetLightStr_Value;
			ATMO_InitValue(&GetLightStr_Value);
			GetLightStr_trigger(value, &GetLightStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetLightStr, triggered), &GetLightStr_Value);
			ATMO_FreeValue(&GetLightStr_Value);
			break;
		}
		case ATMO_ABILITY(GetPressureStr, trigger):
		{
			ATMO_Value_t GetPressureStr_Value;
			ATMO_InitValue(&GetPressureStr_Value);
			GetPressureStr_trigger(value, &GetPressureStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetPressureStr, triggered), &GetPressureStr_Value);
			ATMO_FreeValue(&GetPressureStr_Value);
			break;
		}
		case ATMO_ABILITY(GetAirQualityStr, trigger):
		{
			ATMO_Value_t GetAirQualityStr_Value;
			ATMO_InitValue(&GetAirQualityStr_Value);
			GetAirQualityStr_trigger(value, &GetAirQualityStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetAirQualityStr, triggered), &GetAirQualityStr_Value);
			ATMO_FreeValue(&GetAirQualityStr_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, trigger):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_trigger(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, triggered), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, displayPage):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_displayPage(value, &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, onDisplayed):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_onDisplayed(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, onDisplayed), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, topRightButtonPressed):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_topRightButtonPressed(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, topRightButtonPressed), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, bottomRightButtonPressed):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_bottomRightButtonPressed(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, bottomRightButtonPressed), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, topLeftButtonPressed):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_topLeftButtonPressed(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, topLeftButtonPressed), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_bottomLeftButtonPressed(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, bottomLeftButtonPressed), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, setup):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_setup(value, &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, onLeave):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_onLeave(value, &Humid_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humid_Pg, onLeave), &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Humid_Pg, setLabel):
		{
			ATMO_Value_t Humid_Pg_Value;
			ATMO_InitValue(&Humid_Pg_Value);
			Humid_Pg_setLabel(value, &Humid_Pg_Value);
			ATMO_FreeValue(&Humid_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, trigger):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_trigger(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, triggered), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, displayPage):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_displayPage(value, &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, onDisplayed):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_onDisplayed(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, onDisplayed), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, topRightButtonPressed):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_topRightButtonPressed(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, topRightButtonPressed), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, bottomRightButtonPressed):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_bottomRightButtonPressed(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, bottomRightButtonPressed), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, topLeftButtonPressed):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_topLeftButtonPressed(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, topLeftButtonPressed), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_bottomLeftButtonPressed(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, bottomLeftButtonPressed), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, setup):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_setup(value, &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, onLeave):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_onLeave(value, &Light_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Light_Pg, onLeave), &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Light_Pg, setLabel):
		{
			ATMO_Value_t Light_Pg_Value;
			ATMO_InitValue(&Light_Pg_Value);
			Light_Pg_setLabel(value, &Light_Pg_Value);
			ATMO_FreeValue(&Light_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, trigger):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_trigger(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, triggered), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, displayPage):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_displayPage(value, &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, onDisplayed):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_onDisplayed(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, onDisplayed), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, topRightButtonPressed):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_topRightButtonPressed(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, topRightButtonPressed), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, bottomRightButtonPressed):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_bottomRightButtonPressed(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, bottomRightButtonPressed), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, topLeftButtonPressed):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_topLeftButtonPressed(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, topLeftButtonPressed), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_bottomLeftButtonPressed(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, bottomLeftButtonPressed), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, setup):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_setup(value, &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, onLeave):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_onLeave(value, &Pressure_Pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure_Pg, onLeave), &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(Pressure_Pg, setLabel):
		{
			ATMO_Value_t Pressure_Pg_Value;
			ATMO_InitValue(&Pressure_Pg_Value);
			Pressure_Pg_setLabel(value, &Pressure_Pg_Value);
			ATMO_FreeValue(&Pressure_Pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, trigger):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_trigger(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, triggered), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, displayPage):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_displayPage(value, &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, onDisplayed):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_onDisplayed(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, onDisplayed), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, topRightButtonPressed):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_topRightButtonPressed(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, topRightButtonPressed), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, bottomRightButtonPressed):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_bottomRightButtonPressed(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, bottomRightButtonPressed), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, topLeftButtonPressed):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_topLeftButtonPressed(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, topLeftButtonPressed), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_bottomLeftButtonPressed(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, bottomLeftButtonPressed), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, setup):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_setup(value, &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, onLeave):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_onLeave(value, &VOC_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(VOC_pg, onLeave), &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(VOC_pg, setLabel):
		{
			ATMO_Value_t VOC_pg_Value;
			ATMO_InitValue(&VOC_pg_Value);
			VOC_pg_setLabel(value, &VOC_pg_Value);
			ATMO_FreeValue(&VOC_pg_Value);
			break;
		}
		case ATMO_ABILITY(GetHumidStr, trigger):
		{
			ATMO_Value_t GetHumidStr_Value;
			ATMO_InitValue(&GetHumidStr_Value);
			GetHumidStr_trigger(value, &GetHumidStr_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetHumidStr, triggered), &GetHumidStr_Value);
			ATMO_FreeValue(&GetHumidStr_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, trigger):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_trigger(value, &ENS210TemperatureHumidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(ENS210TemperatureHumidity, triggered), &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, setup):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_setup(value, &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, setEnabled):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_setEnabled(value, &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, setDisabled):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_setDisabled(value, &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, setEnabledDisabled):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_setEnabledDisabled(value, &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, readTemperature):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_readTemperature(value, &ENS210TemperatureHumidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(ENS210TemperatureHumidity, temperatureRead), &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(ENS210TemperatureHumidity, readHumidity):
		{
			ATMO_Value_t ENS210TemperatureHumidity_Value;
			ATMO_InitValue(&ENS210TemperatureHumidity_Value);
			ENS210TemperatureHumidity_readHumidity(value, &ENS210TemperatureHumidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(ENS210TemperatureHumidity, humidityRead), &ENS210TemperatureHumidity_Value);
			ATMO_FreeValue(&ENS210TemperatureHumidity_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, trigger):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_trigger(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, triggered), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, setup):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_setup(value, &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, disconnect):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_disconnect(value, &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, connected):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_connected(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, connected), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, disconnected):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_disconnected(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, disconnected), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, pairingRequested):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_pairingRequested(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, pairingRequested), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, pairingSucceeded):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_pairingSucceeded(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, pairingSucceeded), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(BLEConnection, pairingFailed):
		{
			ATMO_Value_t BLEConnection_Value;
			ATMO_InitValue(&BLEConnection_Value);
			BLEConnection_pairingFailed(value, &BLEConnection_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLEConnection, pairingFailed), &BLEConnection_Value);
			ATMO_FreeValue(&BLEConnection_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, trigger):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_trigger(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, triggered), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, displayPage):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_displayPage(value, &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, onDisplayed):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_onDisplayed(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, onDisplayed), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, topRightButtonPressed):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_topRightButtonPressed(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, topRightButtonPressed), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, bottomRightButtonPressed):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_bottomRightButtonPressed(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, bottomRightButtonPressed), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, topLeftButtonPressed):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_topLeftButtonPressed(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, topLeftButtonPressed), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, bottomLeftButtonPressed):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_bottomLeftButtonPressed(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, bottomLeftButtonPressed), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, setup):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_setup(value, &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, onLeave):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_onLeave(value, &PairingSuccess_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingSuccess, onLeave), &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingSuccess, setLabel):
		{
			ATMO_Value_t PairingSuccess_Value;
			ATMO_InitValue(&PairingSuccess_Value);
			PairingSuccess_setLabel(value, &PairingSuccess_Value);
			ATMO_FreeValue(&PairingSuccess_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, trigger):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_trigger(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, triggered), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, displayPage):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_displayPage(value, &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, onDisplayed):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_onDisplayed(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, onDisplayed), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, topRightButtonPressed):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_topRightButtonPressed(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, topRightButtonPressed), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, bottomRightButtonPressed):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_bottomRightButtonPressed(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, bottomRightButtonPressed), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, topLeftButtonPressed):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_topLeftButtonPressed(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, topLeftButtonPressed), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, bottomLeftButtonPressed):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_bottomLeftButtonPressed(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, bottomLeftButtonPressed), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, setup):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_setup(value, &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, onLeave):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_onLeave(value, &PairingFail_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingFail, onLeave), &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingFail, setLabel):
		{
			ATMO_Value_t PairingFail_Value;
			ATMO_InitValue(&PairingFail_Value);
			PairingFail_setLabel(value, &PairingFail_Value);
			ATMO_FreeValue(&PairingFail_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, trigger):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_trigger(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, triggered), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, displayPage):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_displayPage(value, &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, onDisplayed):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_onDisplayed(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, onDisplayed), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, topRightButtonPressed):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_topRightButtonPressed(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, topRightButtonPressed), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, bottomRightButtonPressed):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_bottomRightButtonPressed(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, bottomRightButtonPressed), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, topLeftButtonPressed):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_topLeftButtonPressed(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, topLeftButtonPressed), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, bottomLeftButtonPressed):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_bottomLeftButtonPressed(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, bottomLeftButtonPressed), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, setup):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_setup(value, &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, onLeave):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_onLeave(value, &PairingCode_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(PairingCode, onLeave), &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(PairingCode, setLabel):
		{
			ATMO_Value_t PairingCode_Value;
			ATMO_InitValue(&PairingCode_Value);
			PairingCode_setLabel(value, &PairingCode_Value);
			ATMO_FreeValue(&PairingCode_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, trigger):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_trigger(value, &BLECharacteristicCustom_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLECharacteristicCustom, triggered), &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, setup):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_setup(value, &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, setValue):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_setValue(value, &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, written):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_written(value, &BLECharacteristicCustom_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLECharacteristicCustom, written), &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, subscibed):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_subscibed(value, &BLECharacteristicCustom_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLECharacteristicCustom, subscibed), &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(BLECharacteristicCustom, unsubscribed):
		{
			ATMO_Value_t BLECharacteristicCustom_Value;
			ATMO_InitValue(&BLECharacteristicCustom_Value);
			BLECharacteristicCustom_unsubscribed(value, &BLECharacteristicCustom_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLECharacteristicCustom, unsubscribed), &BLECharacteristicCustom_Value);
			ATMO_FreeValue(&BLECharacteristicCustom_Value);
			break;
		}
		case ATMO_ABILITY(Variable, trigger):
		{
			ATMO_Value_t Variable_Value;
			ATMO_InitValue(&Variable_Value);
			Variable_trigger(value, &Variable_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Variable, triggered), &Variable_Value);
			ATMO_FreeValue(&Variable_Value);
			break;
		}
		case ATMO_ABILITY(Variable, setup):
		{
			ATMO_Value_t Variable_Value;
			ATMO_InitValue(&Variable_Value);
			Variable_setup(value, &Variable_Value);
			ATMO_FreeValue(&Variable_Value);
			break;
		}
		case ATMO_ABILITY(Variable, setValue):
		{
			ATMO_Value_t Variable_Value;
			ATMO_InitValue(&Variable_Value);
			Variable_setValue(value, &Variable_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Variable, valueSet), &Variable_Value);
			ATMO_FreeValue(&Variable_Value);
			break;
		}
		case ATMO_ABILITY(Variable, getValue):
		{
			ATMO_Value_t Variable_Value;
			ATMO_InitValue(&Variable_Value);
			Variable_getValue(value, &Variable_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Variable, valueRetrieved), &Variable_Value);
			ATMO_FreeValue(&Variable_Value);
			break;
		}
		case ATMO_ABILITY(CO2, trigger):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_trigger(value, &CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CO2, triggered), &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(CO2, setup):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_setup(value, &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(CO2, setValue):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_setValue(value, &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(CO2, written):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_written(value, &CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CO2, written), &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(CO2, subscibed):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_subscibed(value, &CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CO2, subscibed), &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(CO2, unsubscribed):
		{
			ATMO_Value_t CO2_Value;
			ATMO_InitValue(&CO2_Value);
			CO2_unsubscribed(value, &CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(CO2, unsubscribed), &CO2_Value);
			ATMO_FreeValue(&CO2_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, trigger):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_trigger(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, triggered), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, displayPage):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_displayPage(value, &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, onDisplayed):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_onDisplayed(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, onDisplayed), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, topRightButtonPressed):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_topRightButtonPressed(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, topRightButtonPressed), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, bottomRightButtonPressed):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_bottomRightButtonPressed(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, bottomRightButtonPressed), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, topLeftButtonPressed):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_topLeftButtonPressed(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, topLeftButtonPressed), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_bottomLeftButtonPressed(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, bottomLeftButtonPressed), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, setup):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_setup(value, &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, onLeave):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_onLeave(value, &Co2_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Co2_pg, onLeave), &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(Co2_pg, setLabel):
		{
			ATMO_Value_t Co2_pg_Value;
			ATMO_InitValue(&Co2_pg_Value);
			Co2_pg_setLabel(value, &Co2_pg_Value);
			ATMO_FreeValue(&Co2_pg_Value);
			break;
		}
		case ATMO_ABILITY(GetAirQualityStr_CO2, trigger):
		{
			ATMO_Value_t GetAirQualityStr_CO2_Value;
			ATMO_InitValue(&GetAirQualityStr_CO2_Value);
			GetAirQualityStr_CO2_trigger(value, &GetAirQualityStr_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(GetAirQualityStr_CO2, triggered), &GetAirQualityStr_CO2_Value);
			ATMO_FreeValue(&GetAirQualityStr_CO2_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, trigger):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_trigger(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, triggered), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, displayPage):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_displayPage(value, &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, onDisplayed):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_onDisplayed(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, onDisplayed), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, topRightButtonPressed):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_topRightButtonPressed(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, topRightButtonPressed), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, bottomRightButtonPressed):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_bottomRightButtonPressed(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, bottomRightButtonPressed), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, topLeftButtonPressed):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_topLeftButtonPressed(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, topLeftButtonPressed), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, bottomLeftButtonPressed):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_bottomLeftButtonPressed(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, bottomLeftButtonPressed), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, setup):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_setup(value, &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, onLeave):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_onLeave(value, &Temperature_pg_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature_pg, onLeave), &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
		case ATMO_ABILITY(Temperature_pg, setLabel):
		{
			ATMO_Value_t Temperature_pg_Value;
			ATMO_InitValue(&Temperature_pg_Value);
			Temperature_pg_setLabel(value, &Temperature_pg_Value);
			ATMO_FreeValue(&Temperature_pg_Value);
			break;
		}
	}

}

#ifdef __cplusplus
}
#endif
