
#ifndef ATMO_ABILITY_HANDLER_H
#define ATMO_ABILITY_HANDLER_H

#include "atmosphere_platform.h"
#include "atmosphere_callbacks.h"

#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_ABILITY(ELEMENT, NAME) ATMO_ ## ELEMENT ## _ABILITY_  ## NAME

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value);

#define ATMO_getHPa_ABILITY_trigger 0x1
#define ATMO_FastInterval_ABILITY_trigger 0x2
#define ATMO_FastInterval_ABILITY_setup 0x3
#define ATMO_FastInterval_ABILITY_interval 0x4
#define ATMO_TempChar_ABILITY_trigger 0x5
#define ATMO_TempChar_ABILITY_setup 0x6
#define ATMO_TempChar_ABILITY_setValue 0x7
#define ATMO_TempChar_ABILITY_written 0x8
#define ATMO_TempChar_ABILITY_subscibed 0x9
#define ATMO_TempChar_ABILITY_unsubscribed 0xa
#define ATMO_HumidChar_ABILITY_trigger 0xb
#define ATMO_HumidChar_ABILITY_setup 0xc
#define ATMO_HumidChar_ABILITY_setValue 0xd
#define ATMO_HumidChar_ABILITY_written 0xe
#define ATMO_HumidChar_ABILITY_subscibed 0xf
#define ATMO_HumidChar_ABILITY_unsubscribed 0x10
#define ATMO_LightChar_ABILITY_trigger 0x11
#define ATMO_LightChar_ABILITY_setup 0x12
#define ATMO_LightChar_ABILITY_setValue 0x13
#define ATMO_LightChar_ABILITY_written 0x14
#define ATMO_LightChar_ABILITY_subscibed 0x15
#define ATMO_LightChar_ABILITY_unsubscribed 0x16
#define ATMO_PressureChar_ABILITY_trigger 0x17
#define ATMO_PressureChar_ABILITY_setup 0x18
#define ATMO_PressureChar_ABILITY_setValue 0x19
#define ATMO_PressureChar_ABILITY_written 0x1a
#define ATMO_PressureChar_ABILITY_subscibed 0x1b
#define ATMO_PressureChar_ABILITY_unsubscribed 0x1c
#define ATMO_VOC_ABILITY_trigger 0x1d
#define ATMO_VOC_ABILITY_setup 0x1e
#define ATMO_VOC_ABILITY_setValue 0x1f
#define ATMO_VOC_ABILITY_written 0x20
#define ATMO_VOC_ABILITY_subscibed 0x21
#define ATMO_VOC_ABILITY_unsubscribed 0x22
#define ATMO_MPL3115Pressure_ABILITY_trigger 0x23
#define ATMO_MPL3115Pressure_ABILITY_setup 0x24
#define ATMO_MPL3115Pressure_ABILITY_setEnabled 0x25
#define ATMO_MPL3115Pressure_ABILITY_setDisabled 0x26
#define ATMO_MPL3115Pressure_ABILITY_setEnabledDisabled 0x27
#define ATMO_MPL3115Pressure_ABILITY_readAltitude 0x28
#define ATMO_MPL3115Pressure_ABILITY_readPressure 0x29
#define ATMO_MPL3115Pressure_ABILITY_readPressureKpa 0x2a
#define ATMO_TSL2572AmbientLight_ABILITY_trigger 0x2b
#define ATMO_TSL2572AmbientLight_ABILITY_setup 0x2c
#define ATMO_TSL2572AmbientLight_ABILITY_setEnabled 0x2d
#define ATMO_TSL2572AmbientLight_ABILITY_setDisabled 0x2e
#define ATMO_TSL2572AmbientLight_ABILITY_setEnabledDisabled 0x2f
#define ATMO_TSL2572AmbientLight_ABILITY_readAmbientLight 0x30
#define ATMO_CCS811AirQuality_ABILITY_trigger 0x31
#define ATMO_CCS811AirQuality_ABILITY_setup 0x32
#define ATMO_CCS811AirQuality_ABILITY_setEnabled 0x33
#define ATMO_CCS811AirQuality_ABILITY_setDisabled 0x34
#define ATMO_CCS811AirQuality_ABILITY_setEnabledDisabled 0x35
#define ATMO_CCS811AirQuality_ABILITY_readTVOC 0x36
#define ATMO_CCS811AirQuality_ABILITY_readCO2 0x37
#define ATMO_Apps_ABILITY_trigger 0x38
#define ATMO_Apps_ABILITY_displayPage 0x39
#define ATMO_Apps_ABILITY_onDisplayed 0x3a
#define ATMO_Apps_ABILITY_topRightButtonPressed 0x3b
#define ATMO_Apps_ABILITY_bottomRightButtonPressed 0x3c
#define ATMO_Apps_ABILITY_topLeftButtonPressed 0x3d
#define ATMO_Apps_ABILITY_bottomLeftButtonPressed 0x3e
#define ATMO_Apps_ABILITY_setup 0x3f
#define ATMO_Apps_ABILITY_onLeave 0x40
#define ATMO_Apps_ABILITY_setLabel 0x41
#define ATMO_SlowInterval_ABILITY_trigger 0x42
#define ATMO_SlowInterval_ABILITY_setup 0x43
#define ATMO_SlowInterval_ABILITY_interval 0x44
#define ATMO_EmbeddedSystemStatusDisplay_ABILITY_trigger 0x45
#define ATMO_EmbeddedSystemStatusDisplay_ABILITY_displayPage 0x46
#define ATMO_EmbeddedSystemStatusDisplay_ABILITY_onDisplayed 0x47
#define ATMO_EmbeddedSystemStatusDisplay_ABILITY_setup 0x48
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_trigger 0x49
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_setup 0x4a
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_topRightPushed 0x4b
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_bottomRightPushed 0x4c
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_topLeftPushed 0x4d
#define ATMO_EmbeddedNxpRpkUserButtons_ABILITY_bottomLeftPushed 0x4e
#define ATMO_SX9500Touch_ABILITY_trigger 0x4f
#define ATMO_SX9500Touch_ABILITY_setup 0x50
#define ATMO_SX9500Touch_ABILITY_getTouchData 0x51
#define ATMO_SX9500Touch_ABILITY_pressUp 0x52
#define ATMO_SX9500Touch_ABILITY_pressDown 0x53
#define ATMO_SX9500Touch_ABILITY_pressLeft 0x54
#define ATMO_SX9500Touch_ABILITY_pressRight 0x55
#define ATMO_EmbeddedPageController_ABILITY_trigger 0x56
#define ATMO_EmbeddedPageController_ABILITY_setup 0x57
#define ATMO_EmbeddedPageController_ABILITY_displayRootPage 0x58
#define ATMO_EmbeddedPageController_ABILITY_navigateUp 0x59
#define ATMO_EmbeddedPageController_ABILITY_navigateDown 0x5a
#define ATMO_EmbeddedPageController_ABILITY_navigateLeft 0x5b
#define ATMO_EmbeddedPageController_ABILITY_navigateRight 0x5c
#define ATMO_EmbeddedPageController_ABILITY_processTopRightButton 0x5d
#define ATMO_EmbeddedPageController_ABILITY_processBottomRightButton 0x5e
#define ATMO_EmbeddedPageController_ABILITY_processTopLeftButton 0x5f
#define ATMO_EmbeddedPageController_ABILITY_processBottomLeftButton 0x60
#define ATMO_GetTempStr_ABILITY_trigger 0x61
#define ATMO_GetLightStr_ABILITY_trigger 0x62
#define ATMO_GetPressureStr_ABILITY_trigger 0x63
#define ATMO_GetAirQualityStr_ABILITY_trigger 0x64
#define ATMO_Humid_Pg_ABILITY_trigger 0x65
#define ATMO_Humid_Pg_ABILITY_displayPage 0x66
#define ATMO_Humid_Pg_ABILITY_onDisplayed 0x67
#define ATMO_Humid_Pg_ABILITY_topRightButtonPressed 0x68
#define ATMO_Humid_Pg_ABILITY_bottomRightButtonPressed 0x69
#define ATMO_Humid_Pg_ABILITY_topLeftButtonPressed 0x6a
#define ATMO_Humid_Pg_ABILITY_bottomLeftButtonPressed 0x6b
#define ATMO_Humid_Pg_ABILITY_setup 0x6c
#define ATMO_Humid_Pg_ABILITY_onLeave 0x6d
#define ATMO_Humid_Pg_ABILITY_setLabel 0x6e
#define ATMO_Light_Pg_ABILITY_trigger 0x6f
#define ATMO_Light_Pg_ABILITY_displayPage 0x70
#define ATMO_Light_Pg_ABILITY_onDisplayed 0x71
#define ATMO_Light_Pg_ABILITY_topRightButtonPressed 0x72
#define ATMO_Light_Pg_ABILITY_bottomRightButtonPressed 0x73
#define ATMO_Light_Pg_ABILITY_topLeftButtonPressed 0x74
#define ATMO_Light_Pg_ABILITY_bottomLeftButtonPressed 0x75
#define ATMO_Light_Pg_ABILITY_setup 0x76
#define ATMO_Light_Pg_ABILITY_onLeave 0x77
#define ATMO_Light_Pg_ABILITY_setLabel 0x78
#define ATMO_Pressure_Pg_ABILITY_trigger 0x79
#define ATMO_Pressure_Pg_ABILITY_displayPage 0x7a
#define ATMO_Pressure_Pg_ABILITY_onDisplayed 0x7b
#define ATMO_Pressure_Pg_ABILITY_topRightButtonPressed 0x7c
#define ATMO_Pressure_Pg_ABILITY_bottomRightButtonPressed 0x7d
#define ATMO_Pressure_Pg_ABILITY_topLeftButtonPressed 0x7e
#define ATMO_Pressure_Pg_ABILITY_bottomLeftButtonPressed 0x7f
#define ATMO_Pressure_Pg_ABILITY_setup 0x80
#define ATMO_Pressure_Pg_ABILITY_onLeave 0x81
#define ATMO_Pressure_Pg_ABILITY_setLabel 0x82
#define ATMO_VOC_pg_ABILITY_trigger 0x83
#define ATMO_VOC_pg_ABILITY_displayPage 0x84
#define ATMO_VOC_pg_ABILITY_onDisplayed 0x85
#define ATMO_VOC_pg_ABILITY_topRightButtonPressed 0x86
#define ATMO_VOC_pg_ABILITY_bottomRightButtonPressed 0x87
#define ATMO_VOC_pg_ABILITY_topLeftButtonPressed 0x88
#define ATMO_VOC_pg_ABILITY_bottomLeftButtonPressed 0x89
#define ATMO_VOC_pg_ABILITY_setup 0x8a
#define ATMO_VOC_pg_ABILITY_onLeave 0x8b
#define ATMO_VOC_pg_ABILITY_setLabel 0x8c
#define ATMO_GetHumidStr_ABILITY_trigger 0x8d
#define ATMO_ENS210TemperatureHumidity_ABILITY_trigger 0x8e
#define ATMO_ENS210TemperatureHumidity_ABILITY_setup 0x8f
#define ATMO_ENS210TemperatureHumidity_ABILITY_setEnabled 0x90
#define ATMO_ENS210TemperatureHumidity_ABILITY_setDisabled 0x91
#define ATMO_ENS210TemperatureHumidity_ABILITY_setEnabledDisabled 0x92
#define ATMO_ENS210TemperatureHumidity_ABILITY_readTemperature 0x93
#define ATMO_ENS210TemperatureHumidity_ABILITY_readHumidity 0x94
#define ATMO_BLEConnection_ABILITY_trigger 0x95
#define ATMO_BLEConnection_ABILITY_setup 0x96
#define ATMO_BLEConnection_ABILITY_disconnect 0x97
#define ATMO_BLEConnection_ABILITY_connected 0x98
#define ATMO_BLEConnection_ABILITY_disconnected 0x99
#define ATMO_BLEConnection_ABILITY_pairingRequested 0x9a
#define ATMO_BLEConnection_ABILITY_pairingSucceeded 0x9b
#define ATMO_BLEConnection_ABILITY_pairingFailed 0x9c
#define ATMO_PairingSuccess_ABILITY_trigger 0x9d
#define ATMO_PairingSuccess_ABILITY_displayPage 0x9e
#define ATMO_PairingSuccess_ABILITY_onDisplayed 0x9f
#define ATMO_PairingSuccess_ABILITY_topRightButtonPressed 0xa0
#define ATMO_PairingSuccess_ABILITY_bottomRightButtonPressed 0xa1
#define ATMO_PairingSuccess_ABILITY_topLeftButtonPressed 0xa2
#define ATMO_PairingSuccess_ABILITY_bottomLeftButtonPressed 0xa3
#define ATMO_PairingSuccess_ABILITY_setup 0xa4
#define ATMO_PairingSuccess_ABILITY_onLeave 0xa5
#define ATMO_PairingSuccess_ABILITY_setLabel 0xa6
#define ATMO_PairingFail_ABILITY_trigger 0xa7
#define ATMO_PairingFail_ABILITY_displayPage 0xa8
#define ATMO_PairingFail_ABILITY_onDisplayed 0xa9
#define ATMO_PairingFail_ABILITY_topRightButtonPressed 0xaa
#define ATMO_PairingFail_ABILITY_bottomRightButtonPressed 0xab
#define ATMO_PairingFail_ABILITY_topLeftButtonPressed 0xac
#define ATMO_PairingFail_ABILITY_bottomLeftButtonPressed 0xad
#define ATMO_PairingFail_ABILITY_setup 0xae
#define ATMO_PairingFail_ABILITY_onLeave 0xaf
#define ATMO_PairingFail_ABILITY_setLabel 0xb0
#define ATMO_PairingCode_ABILITY_trigger 0xb1
#define ATMO_PairingCode_ABILITY_displayPage 0xb2
#define ATMO_PairingCode_ABILITY_onDisplayed 0xb3
#define ATMO_PairingCode_ABILITY_topRightButtonPressed 0xb4
#define ATMO_PairingCode_ABILITY_bottomRightButtonPressed 0xb5
#define ATMO_PairingCode_ABILITY_topLeftButtonPressed 0xb6
#define ATMO_PairingCode_ABILITY_bottomLeftButtonPressed 0xb7
#define ATMO_PairingCode_ABILITY_setup 0xb8
#define ATMO_PairingCode_ABILITY_onLeave 0xb9
#define ATMO_PairingCode_ABILITY_setLabel 0xba
#define ATMO_BLECharacteristicCustom_ABILITY_trigger 0xbb
#define ATMO_BLECharacteristicCustom_ABILITY_setup 0xbc
#define ATMO_BLECharacteristicCustom_ABILITY_setValue 0xbd
#define ATMO_BLECharacteristicCustom_ABILITY_written 0xbe
#define ATMO_BLECharacteristicCustom_ABILITY_subscibed 0xbf
#define ATMO_BLECharacteristicCustom_ABILITY_unsubscribed 0xc0
#define ATMO_Variable_ABILITY_trigger 0xc1
#define ATMO_Variable_ABILITY_setup 0xc2
#define ATMO_Variable_ABILITY_setValue 0xc3
#define ATMO_Variable_ABILITY_getValue 0xc4
#define ATMO_CO2_ABILITY_trigger 0xc5
#define ATMO_CO2_ABILITY_setup 0xc6
#define ATMO_CO2_ABILITY_setValue 0xc7
#define ATMO_CO2_ABILITY_written 0xc8
#define ATMO_CO2_ABILITY_subscibed 0xc9
#define ATMO_CO2_ABILITY_unsubscribed 0xca
#define ATMO_Co2_pg_ABILITY_trigger 0xcb
#define ATMO_Co2_pg_ABILITY_displayPage 0xcc
#define ATMO_Co2_pg_ABILITY_onDisplayed 0xcd
#define ATMO_Co2_pg_ABILITY_topRightButtonPressed 0xce
#define ATMO_Co2_pg_ABILITY_bottomRightButtonPressed 0xcf
#define ATMO_Co2_pg_ABILITY_topLeftButtonPressed 0xd0
#define ATMO_Co2_pg_ABILITY_bottomLeftButtonPressed 0xd1
#define ATMO_Co2_pg_ABILITY_setup 0xd2
#define ATMO_Co2_pg_ABILITY_onLeave 0xd3
#define ATMO_Co2_pg_ABILITY_setLabel 0xd4
#define ATMO_GetAirQualityStr_CO2_ABILITY_trigger 0xd5
#define ATMO_Temperature_pg_ABILITY_trigger 0xd6
#define ATMO_Temperature_pg_ABILITY_displayPage 0xd7
#define ATMO_Temperature_pg_ABILITY_onDisplayed 0xd8
#define ATMO_Temperature_pg_ABILITY_topRightButtonPressed 0xd9
#define ATMO_Temperature_pg_ABILITY_bottomRightButtonPressed 0xda
#define ATMO_Temperature_pg_ABILITY_topLeftButtonPressed 0xdb
#define ATMO_Temperature_pg_ABILITY_bottomLeftButtonPressed 0xdc
#define ATMO_Temperature_pg_ABILITY_setup 0xdd
#define ATMO_Temperature_pg_ABILITY_onLeave 0xde
#define ATMO_Temperature_pg_ABILITY_setLabel 0xdf
#ifdef __cplusplus
}
#endif
#endif
