
#ifndef ATMO_CALLBACKS_H
#define ATMO_CALLBACKS_H

#include "atmosphere_platform.h"
#include "atmosphere_properties.h"
#include "atmosphere_variables.h"
#include "atmosphere_triggerHandler.h"
#include "atmosphere_interruptsHandler.h"
#include "atmosphere_embedded_libraries.h"
#include "atmosphere_abilityHandler.h"

#include "atmosphere_driverinstance.h"

#define ATMO_CALLBACK(ELEMENT, NAME) ELEMENT ## _ ## NAME

void ATMO_Setup();

ATMO_Status_t getHPa_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t FastInterval_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t FastInterval_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t FastInterval_interval(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TempChar_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t HumidChar_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t LightChar_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PressureChar_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_readAltitude(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_readPressure(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t MPL3115Pressure_readPressureKpa(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t TSL2572AmbientLight_readAmbientLight(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_readTVOC(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CCS811AirQuality_readCO2(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Apps_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SlowInterval_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SlowInterval_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SlowInterval_interval(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedSystemStatusDisplay_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedSystemStatusDisplay_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedSystemStatusDisplay_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedSystemStatusDisplay_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_topRightPushed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_bottomRightPushed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_topLeftPushed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkUserButtons_bottomLeftPushed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_getTouchData(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_pressUp(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_pressDown(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_pressLeft(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t SX9500Touch_pressRight(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_displayRootPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_navigateUp(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_navigateDown(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_navigateLeft(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_navigateRight(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_processTopRightButton(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_processBottomRightButton(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_processTopLeftButton(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedPageController_processBottomLeftButton(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetTempStr_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetLightStr_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetPressureStr_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetAirQualityStr_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humid_Pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Light_Pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_Pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t VOC_pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetHumidStr_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_readTemperature(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t ENS210TemperatureHumidity_readHumidity(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_disconnect(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_connected(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_disconnected(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_pairingRequested(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_pairingSucceeded(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLEConnection_pairingFailed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingSuccess_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingFail_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t PairingCode_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Variable_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Variable_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Variable_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Variable_getValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t CO2_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Co2_pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GetAirQualityStr_CO2_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_displayPage(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_onDisplayed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_topRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_bottomRightButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_topLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_bottomLeftButtonPressed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_onLeave(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_pg_setLabel(ATMO_Value_t *in, ATMO_Value_t *out);
#endif
