
#ifndef ATMO_INTERRUPTS_HANDLER_H
#define ATMO_INTERRUPTS_HANDLER_H

#ifdef __cplusplus
	extern "C"{
#endif

#include "../atmo/core.h"
#define ATMO_INTERRUPT(ELEMENT, NAME) ATMO_ ## ELEMENT ## _INTERRUPT_  ## NAME

void ATMO_getHPa_INTERRUPT_trigger();

void ATMO_FastInterval_INTERRUPT_trigger();
void ATMO_FastInterval_INTERRUPT_setup();
void ATMO_FastInterval_INTERRUPT_interval();

void ATMO_TempChar_INTERRUPT_trigger();
void ATMO_TempChar_INTERRUPT_setup();
void ATMO_TempChar_INTERRUPT_setValue();
void ATMO_TempChar_INTERRUPT_written();
void ATMO_TempChar_INTERRUPT_subscibed();
void ATMO_TempChar_INTERRUPT_unsubscribed();

void ATMO_HumidChar_INTERRUPT_trigger();
void ATMO_HumidChar_INTERRUPT_setup();
void ATMO_HumidChar_INTERRUPT_setValue();
void ATMO_HumidChar_INTERRUPT_written();
void ATMO_HumidChar_INTERRUPT_subscibed();
void ATMO_HumidChar_INTERRUPT_unsubscribed();

void ATMO_LightChar_INTERRUPT_trigger();
void ATMO_LightChar_INTERRUPT_setup();
void ATMO_LightChar_INTERRUPT_setValue();
void ATMO_LightChar_INTERRUPT_written();
void ATMO_LightChar_INTERRUPT_subscibed();
void ATMO_LightChar_INTERRUPT_unsubscribed();

void ATMO_PressureChar_INTERRUPT_trigger();
void ATMO_PressureChar_INTERRUPT_setup();
void ATMO_PressureChar_INTERRUPT_setValue();
void ATMO_PressureChar_INTERRUPT_written();
void ATMO_PressureChar_INTERRUPT_subscibed();
void ATMO_PressureChar_INTERRUPT_unsubscribed();

void ATMO_VOC_INTERRUPT_trigger();
void ATMO_VOC_INTERRUPT_setup();
void ATMO_VOC_INTERRUPT_setValue();
void ATMO_VOC_INTERRUPT_written();
void ATMO_VOC_INTERRUPT_subscibed();
void ATMO_VOC_INTERRUPT_unsubscribed();

void ATMO_MPL3115Pressure_INTERRUPT_trigger();
void ATMO_MPL3115Pressure_INTERRUPT_setup();
void ATMO_MPL3115Pressure_INTERRUPT_setEnabled();
void ATMO_MPL3115Pressure_INTERRUPT_setDisabled();
void ATMO_MPL3115Pressure_INTERRUPT_setEnabledDisabled();
void ATMO_MPL3115Pressure_INTERRUPT_readAltitude();
void ATMO_MPL3115Pressure_INTERRUPT_readPressure();
void ATMO_MPL3115Pressure_INTERRUPT_readPressureKpa();

void ATMO_TSL2572AmbientLight_INTERRUPT_trigger();
void ATMO_TSL2572AmbientLight_INTERRUPT_setup();
void ATMO_TSL2572AmbientLight_INTERRUPT_setEnabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_setDisabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_setEnabledDisabled();
void ATMO_TSL2572AmbientLight_INTERRUPT_readAmbientLight();

void ATMO_CCS811AirQuality_INTERRUPT_trigger();
void ATMO_CCS811AirQuality_INTERRUPT_setup();
void ATMO_CCS811AirQuality_INTERRUPT_setEnabled();
void ATMO_CCS811AirQuality_INTERRUPT_setDisabled();
void ATMO_CCS811AirQuality_INTERRUPT_setEnabledDisabled();
void ATMO_CCS811AirQuality_INTERRUPT_readTVOC();
void ATMO_CCS811AirQuality_INTERRUPT_readCO2();

void ATMO_Apps_INTERRUPT_trigger();
void ATMO_Apps_INTERRUPT_displayPage();
void ATMO_Apps_INTERRUPT_onDisplayed();
void ATMO_Apps_INTERRUPT_topRightButtonPressed();
void ATMO_Apps_INTERRUPT_bottomRightButtonPressed();
void ATMO_Apps_INTERRUPT_topLeftButtonPressed();
void ATMO_Apps_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Apps_INTERRUPT_setup();
void ATMO_Apps_INTERRUPT_onLeave();
void ATMO_Apps_INTERRUPT_setLabel();

void ATMO_SlowInterval_INTERRUPT_trigger();
void ATMO_SlowInterval_INTERRUPT_setup();
void ATMO_SlowInterval_INTERRUPT_interval();

void ATMO_EmbeddedSystemStatusDisplay_INTERRUPT_trigger();
void ATMO_EmbeddedSystemStatusDisplay_INTERRUPT_displayPage();
void ATMO_EmbeddedSystemStatusDisplay_INTERRUPT_onDisplayed();
void ATMO_EmbeddedSystemStatusDisplay_INTERRUPT_setup();

void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_trigger();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_setup();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_topRightPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_bottomRightPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_topLeftPushed();
void ATMO_EmbeddedNxpRpkUserButtons_INTERRUPT_bottomLeftPushed();

void ATMO_SX9500Touch_INTERRUPT_trigger();
void ATMO_SX9500Touch_INTERRUPT_setup();
void ATMO_SX9500Touch_INTERRUPT_getTouchData();
void ATMO_SX9500Touch_INTERRUPT_pressUp();
void ATMO_SX9500Touch_INTERRUPT_pressDown();
void ATMO_SX9500Touch_INTERRUPT_pressLeft();
void ATMO_SX9500Touch_INTERRUPT_pressRight();

void ATMO_EmbeddedPageController_INTERRUPT_trigger();
void ATMO_EmbeddedPageController_INTERRUPT_setup();
void ATMO_EmbeddedPageController_INTERRUPT_displayRootPage();
void ATMO_EmbeddedPageController_INTERRUPT_navigateUp();
void ATMO_EmbeddedPageController_INTERRUPT_navigateDown();
void ATMO_EmbeddedPageController_INTERRUPT_navigateLeft();
void ATMO_EmbeddedPageController_INTERRUPT_navigateRight();
void ATMO_EmbeddedPageController_INTERRUPT_processTopRightButton();
void ATMO_EmbeddedPageController_INTERRUPT_processBottomRightButton();
void ATMO_EmbeddedPageController_INTERRUPT_processTopLeftButton();
void ATMO_EmbeddedPageController_INTERRUPT_processBottomLeftButton();

void ATMO_GetTempStr_INTERRUPT_trigger();

void ATMO_GetLightStr_INTERRUPT_trigger();

void ATMO_GetPressureStr_INTERRUPT_trigger();

void ATMO_GetAirQualityStr_INTERRUPT_trigger();

void ATMO_Humid_Pg_INTERRUPT_trigger();
void ATMO_Humid_Pg_INTERRUPT_displayPage();
void ATMO_Humid_Pg_INTERRUPT_onDisplayed();
void ATMO_Humid_Pg_INTERRUPT_topRightButtonPressed();
void ATMO_Humid_Pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_Humid_Pg_INTERRUPT_topLeftButtonPressed();
void ATMO_Humid_Pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Humid_Pg_INTERRUPT_setup();
void ATMO_Humid_Pg_INTERRUPT_onLeave();
void ATMO_Humid_Pg_INTERRUPT_setLabel();

void ATMO_Light_Pg_INTERRUPT_trigger();
void ATMO_Light_Pg_INTERRUPT_displayPage();
void ATMO_Light_Pg_INTERRUPT_onDisplayed();
void ATMO_Light_Pg_INTERRUPT_topRightButtonPressed();
void ATMO_Light_Pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_Light_Pg_INTERRUPT_topLeftButtonPressed();
void ATMO_Light_Pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Light_Pg_INTERRUPT_setup();
void ATMO_Light_Pg_INTERRUPT_onLeave();
void ATMO_Light_Pg_INTERRUPT_setLabel();

void ATMO_Pressure_Pg_INTERRUPT_trigger();
void ATMO_Pressure_Pg_INTERRUPT_displayPage();
void ATMO_Pressure_Pg_INTERRUPT_onDisplayed();
void ATMO_Pressure_Pg_INTERRUPT_topRightButtonPressed();
void ATMO_Pressure_Pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_Pressure_Pg_INTERRUPT_topLeftButtonPressed();
void ATMO_Pressure_Pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Pressure_Pg_INTERRUPT_setup();
void ATMO_Pressure_Pg_INTERRUPT_onLeave();
void ATMO_Pressure_Pg_INTERRUPT_setLabel();

void ATMO_VOC_pg_INTERRUPT_trigger();
void ATMO_VOC_pg_INTERRUPT_displayPage();
void ATMO_VOC_pg_INTERRUPT_onDisplayed();
void ATMO_VOC_pg_INTERRUPT_topRightButtonPressed();
void ATMO_VOC_pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_VOC_pg_INTERRUPT_topLeftButtonPressed();
void ATMO_VOC_pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_VOC_pg_INTERRUPT_setup();
void ATMO_VOC_pg_INTERRUPT_onLeave();
void ATMO_VOC_pg_INTERRUPT_setLabel();

void ATMO_GetHumidStr_INTERRUPT_trigger();

void ATMO_ENS210TemperatureHumidity_INTERRUPT_trigger();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_setup();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_setEnabled();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_setDisabled();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_setEnabledDisabled();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_readTemperature();
void ATMO_ENS210TemperatureHumidity_INTERRUPT_readHumidity();

void ATMO_BLEConnection_INTERRUPT_trigger();
void ATMO_BLEConnection_INTERRUPT_setup();
void ATMO_BLEConnection_INTERRUPT_disconnect();
void ATMO_BLEConnection_INTERRUPT_connected();
void ATMO_BLEConnection_INTERRUPT_disconnected();
void ATMO_BLEConnection_INTERRUPT_pairingRequested();
void ATMO_BLEConnection_INTERRUPT_pairingSucceeded();
void ATMO_BLEConnection_INTERRUPT_pairingFailed();

void ATMO_PairingSuccess_INTERRUPT_trigger();
void ATMO_PairingSuccess_INTERRUPT_displayPage();
void ATMO_PairingSuccess_INTERRUPT_onDisplayed();
void ATMO_PairingSuccess_INTERRUPT_topRightButtonPressed();
void ATMO_PairingSuccess_INTERRUPT_bottomRightButtonPressed();
void ATMO_PairingSuccess_INTERRUPT_topLeftButtonPressed();
void ATMO_PairingSuccess_INTERRUPT_bottomLeftButtonPressed();
void ATMO_PairingSuccess_INTERRUPT_setup();
void ATMO_PairingSuccess_INTERRUPT_onLeave();
void ATMO_PairingSuccess_INTERRUPT_setLabel();

void ATMO_PairingFail_INTERRUPT_trigger();
void ATMO_PairingFail_INTERRUPT_displayPage();
void ATMO_PairingFail_INTERRUPT_onDisplayed();
void ATMO_PairingFail_INTERRUPT_topRightButtonPressed();
void ATMO_PairingFail_INTERRUPT_bottomRightButtonPressed();
void ATMO_PairingFail_INTERRUPT_topLeftButtonPressed();
void ATMO_PairingFail_INTERRUPT_bottomLeftButtonPressed();
void ATMO_PairingFail_INTERRUPT_setup();
void ATMO_PairingFail_INTERRUPT_onLeave();
void ATMO_PairingFail_INTERRUPT_setLabel();

void ATMO_PairingCode_INTERRUPT_trigger();
void ATMO_PairingCode_INTERRUPT_displayPage();
void ATMO_PairingCode_INTERRUPT_onDisplayed();
void ATMO_PairingCode_INTERRUPT_topRightButtonPressed();
void ATMO_PairingCode_INTERRUPT_bottomRightButtonPressed();
void ATMO_PairingCode_INTERRUPT_topLeftButtonPressed();
void ATMO_PairingCode_INTERRUPT_bottomLeftButtonPressed();
void ATMO_PairingCode_INTERRUPT_setup();
void ATMO_PairingCode_INTERRUPT_onLeave();
void ATMO_PairingCode_INTERRUPT_setLabel();

void ATMO_BLECharacteristicCustom_INTERRUPT_trigger();
void ATMO_BLECharacteristicCustom_INTERRUPT_setup();
void ATMO_BLECharacteristicCustom_INTERRUPT_setValue();
void ATMO_BLECharacteristicCustom_INTERRUPT_written();
void ATMO_BLECharacteristicCustom_INTERRUPT_subscibed();
void ATMO_BLECharacteristicCustom_INTERRUPT_unsubscribed();

void ATMO_Variable_INTERRUPT_trigger();
void ATMO_Variable_INTERRUPT_setup();
void ATMO_Variable_INTERRUPT_setValue();
void ATMO_Variable_INTERRUPT_getValue();

void ATMO_CO2_INTERRUPT_trigger();
void ATMO_CO2_INTERRUPT_setup();
void ATMO_CO2_INTERRUPT_setValue();
void ATMO_CO2_INTERRUPT_written();
void ATMO_CO2_INTERRUPT_subscibed();
void ATMO_CO2_INTERRUPT_unsubscribed();

void ATMO_Co2_pg_INTERRUPT_trigger();
void ATMO_Co2_pg_INTERRUPT_displayPage();
void ATMO_Co2_pg_INTERRUPT_onDisplayed();
void ATMO_Co2_pg_INTERRUPT_topRightButtonPressed();
void ATMO_Co2_pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_Co2_pg_INTERRUPT_topLeftButtonPressed();
void ATMO_Co2_pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Co2_pg_INTERRUPT_setup();
void ATMO_Co2_pg_INTERRUPT_onLeave();
void ATMO_Co2_pg_INTERRUPT_setLabel();

void ATMO_GetAirQualityStr_CO2_INTERRUPT_trigger();

void ATMO_Temperature_pg_INTERRUPT_trigger();
void ATMO_Temperature_pg_INTERRUPT_displayPage();
void ATMO_Temperature_pg_INTERRUPT_onDisplayed();
void ATMO_Temperature_pg_INTERRUPT_topRightButtonPressed();
void ATMO_Temperature_pg_INTERRUPT_bottomRightButtonPressed();
void ATMO_Temperature_pg_INTERRUPT_topLeftButtonPressed();
void ATMO_Temperature_pg_INTERRUPT_bottomLeftButtonPressed();
void ATMO_Temperature_pg_INTERRUPT_setup();
void ATMO_Temperature_pg_INTERRUPT_onLeave();
void ATMO_Temperature_pg_INTERRUPT_setLabel();


#ifdef __cplusplus
}
#endif

#endif
