#include "atmosphere_triggerHandler.h"
#include "atmosphere_abilityHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_TriggerHandler(unsigned int triggerHandleId, ATMO_Value_t *value) {
	switch(triggerHandleId) {
		case ATMO_TRIGGER(getHPa, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetPressureStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(FastInterval, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(FastInterval, interval):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(TSL2572AmbientLight, readAmbientLight), value);
			ATMO_AbilityHandler(ATMO_ABILITY(CCS811AirQuality, readTVOC), value);
			break;
		}

		case ATMO_TRIGGER(TempChar, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(TempChar, written):
		{
			break;
		}

		case ATMO_TRIGGER(TempChar, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(TempChar, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(HumidChar, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(HumidChar, written):
		{
			break;
		}

		case ATMO_TRIGGER(HumidChar, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(HumidChar, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(LightChar, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(LightChar, written):
		{
			break;
		}

		case ATMO_TRIGGER(LightChar, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(LightChar, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(PressureChar, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(PressureChar, written):
		{
			break;
		}

		case ATMO_TRIGGER(PressureChar, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(PressureChar, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(VOC, written):
		{
			break;
		}

		case ATMO_TRIGGER(VOC, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(MPL3115Pressure, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(MPL3115Pressure, altitudeRead):
		{
			break;
		}

		case ATMO_TRIGGER(MPL3115Pressure, pressureRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(getHPa, trigger), value);
			break;
		}

		case ATMO_TRIGGER(MPL3115Pressure, pressureReadKpa):
		{
			break;
		}

		case ATMO_TRIGGER(TSL2572AmbientLight, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(TSL2572AmbientLight, ambientLightRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetLightStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(CCS811AirQuality, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(CCS811AirQuality, TVOCRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetAirQualityStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(CCS811AirQuality, CO2Read):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetAirQualityStr_CO2, trigger), value);
			break;
		}

		case ATMO_TRIGGER(Apps, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Apps, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(SlowInterval, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(SlowInterval, interval):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(MPL3115Pressure, readPressure), value);
			ATMO_AbilityHandler(ATMO_ABILITY(CCS811AirQuality, readCO2), value);
			ATMO_AbilityHandler(ATMO_ABILITY(ENS210TemperatureHumidity, readTemperature), value);
			ATMO_AbilityHandler(ATMO_ABILITY(ENS210TemperatureHumidity, readHumidity), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedSystemStatusDisplay, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedSystemStatusDisplay, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topRightPushed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, processTopRightButton), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomRightPushed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, processBottomRightButton), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, topLeftPushed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, processTopLeftButton), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedNxpRpkUserButtons, bottomLeftPushed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, processBottomLeftButton), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, touchDataRead):
		{
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, upPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateUp), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, downPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateDown), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, leftPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateLeft), value);
			break;
		}

		case ATMO_TRIGGER(SX9500Touch, rightPressed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(EmbeddedPageController, navigateRight), value);
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateUp):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateDown):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateLeft):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, navigateRight):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processTopRightButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processBottomRightButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processTopLeftButton):
		{
			break;
		}

		case ATMO_TRIGGER(EmbeddedPageController, processBottomLeftButton):
		{
			break;
		}

		case ATMO_TRIGGER(GetTempStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(Temperature_pg, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(TempChar, setValue), value);
			break;
		}

		case ATMO_TRIGGER(GetLightStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(Light_Pg, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(LightChar, setValue), value);
			break;
		}

		case ATMO_TRIGGER(GetPressureStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(Pressure_Pg, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(PressureChar, setValue), value);
			break;
		}

		case ATMO_TRIGGER(GetAirQualityStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(VOC, setValue), value);
			ATMO_AbilityHandler(ATMO_ABILITY(VOC_pg, setLabel), value);
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Humid_Pg, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Light_Pg, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure_Pg, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(VOC_pg, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(GetHumidStr, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(Humid_Pg, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(HumidChar, setValue), value);
			break;
		}

		case ATMO_TRIGGER(ENS210TemperatureHumidity, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(ENS210TemperatureHumidity, temperatureRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetTempStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(ENS210TemperatureHumidity, humidityRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(GetHumidStr, trigger), value);
			break;
		}

		case ATMO_TRIGGER(BLEConnection, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLEConnection, connected):
		{
			break;
		}

		case ATMO_TRIGGER(BLEConnection, disconnected):
		{
			break;
		}

		case ATMO_TRIGGER(BLEConnection, pairingRequested):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(PairingCode, setLabel), value);
			ATMO_AbilityHandler(ATMO_ABILITY(PairingCode, displayPage), value);
			break;
		}

		case ATMO_TRIGGER(BLEConnection, pairingSucceeded):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(PairingSuccess, displayPage), value);
			break;
		}

		case ATMO_TRIGGER(BLEConnection, pairingFailed):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(PairingFail, displayPage), value);
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingSuccess, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingFail, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(PairingCode, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(BLECharacteristicCustom, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLECharacteristicCustom, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLECharacteristicCustom, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLECharacteristicCustom, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Variable, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Variable, valueSet):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLECharacteristicCustom, written), value);
			break;
		}

		case ATMO_TRIGGER(Variable, valueRetrieved):
		{
			break;
		}

		case ATMO_TRIGGER(CO2, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(CO2, written):
		{
			break;
		}

		case ATMO_TRIGGER(CO2, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(CO2, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Co2_pg, onLeave):
		{
			break;
		}

		case ATMO_TRIGGER(GetAirQualityStr_CO2, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(CO2, setValue), value);
			ATMO_AbilityHandler(ATMO_ABILITY(Co2_pg, setLabel), value);
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, onDisplayed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, topRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, bottomRightButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, topLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, bottomLeftButtonPressed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature_pg, onLeave):
		{
			break;
		}

	}

}

#ifdef __cplusplus
}
#endif
