
#ifndef ATMO_TRIGGER_HANDLER_H
#define ATMO_TRIGGER_HANDLER_H

#include "atmosphere_platform.h"
#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_TRIGGER(ELEMENT, NAME) ATMO_ ## ELEMENT ## _TRIGGER_  ## NAME

void ATMO_TriggerHandler(unsigned int triggerHandleId, ATMO_Value_t *value);

#define ATMO_getHPa_TRIGGER_triggered 0x1
#define ATMO_FastInterval_TRIGGER_triggered 0x2
#define ATMO_FastInterval_TRIGGER_interval 0x3
#define ATMO_TempChar_TRIGGER_triggered 0x4
#define ATMO_TempChar_TRIGGER_written 0x5
#define ATMO_TempChar_TRIGGER_subscibed 0x6
#define ATMO_TempChar_TRIGGER_unsubscribed 0x7
#define ATMO_HumidChar_TRIGGER_triggered 0x8
#define ATMO_HumidChar_TRIGGER_written 0x9
#define ATMO_HumidChar_TRIGGER_subscibed 0xa
#define ATMO_HumidChar_TRIGGER_unsubscribed 0xb
#define ATMO_LightChar_TRIGGER_triggered 0xc
#define ATMO_LightChar_TRIGGER_written 0xd
#define ATMO_LightChar_TRIGGER_subscibed 0xe
#define ATMO_LightChar_TRIGGER_unsubscribed 0xf
#define ATMO_PressureChar_TRIGGER_triggered 0x10
#define ATMO_PressureChar_TRIGGER_written 0x11
#define ATMO_PressureChar_TRIGGER_subscibed 0x12
#define ATMO_PressureChar_TRIGGER_unsubscribed 0x13
#define ATMO_VOC_TRIGGER_triggered 0x14
#define ATMO_VOC_TRIGGER_written 0x15
#define ATMO_VOC_TRIGGER_subscibed 0x16
#define ATMO_VOC_TRIGGER_unsubscribed 0x17
#define ATMO_MPL3115Pressure_TRIGGER_triggered 0x18
#define ATMO_MPL3115Pressure_TRIGGER_altitudeRead 0x19
#define ATMO_MPL3115Pressure_TRIGGER_pressureRead 0x1a
#define ATMO_MPL3115Pressure_TRIGGER_pressureReadKpa 0x1b
#define ATMO_TSL2572AmbientLight_TRIGGER_triggered 0x1c
#define ATMO_TSL2572AmbientLight_TRIGGER_ambientLightRead 0x1d
#define ATMO_CCS811AirQuality_TRIGGER_triggered 0x1e
#define ATMO_CCS811AirQuality_TRIGGER_TVOCRead 0x1f
#define ATMO_CCS811AirQuality_TRIGGER_CO2Read 0x20
#define ATMO_Apps_TRIGGER_triggered 0x21
#define ATMO_Apps_TRIGGER_onDisplayed 0x22
#define ATMO_Apps_TRIGGER_topRightButtonPressed 0x23
#define ATMO_Apps_TRIGGER_bottomRightButtonPressed 0x24
#define ATMO_Apps_TRIGGER_topLeftButtonPressed 0x25
#define ATMO_Apps_TRIGGER_bottomLeftButtonPressed 0x26
#define ATMO_Apps_TRIGGER_onLeave 0x27
#define ATMO_SlowInterval_TRIGGER_triggered 0x28
#define ATMO_SlowInterval_TRIGGER_interval 0x29
#define ATMO_EmbeddedSystemStatusDisplay_TRIGGER_triggered 0x2a
#define ATMO_EmbeddedSystemStatusDisplay_TRIGGER_onDisplayed 0x2b
#define ATMO_EmbeddedNxpRpkUserButtons_TRIGGER_triggered 0x2c
#define ATMO_EmbeddedNxpRpkUserButtons_TRIGGER_topRightPushed 0x2d
#define ATMO_EmbeddedNxpRpkUserButtons_TRIGGER_bottomRightPushed 0x2e
#define ATMO_EmbeddedNxpRpkUserButtons_TRIGGER_topLeftPushed 0x2f
#define ATMO_EmbeddedNxpRpkUserButtons_TRIGGER_bottomLeftPushed 0x30
#define ATMO_SX9500Touch_TRIGGER_triggered 0x31
#define ATMO_SX9500Touch_TRIGGER_touchDataRead 0x32
#define ATMO_SX9500Touch_TRIGGER_upPressed 0x33
#define ATMO_SX9500Touch_TRIGGER_downPressed 0x34
#define ATMO_SX9500Touch_TRIGGER_leftPressed 0x35
#define ATMO_SX9500Touch_TRIGGER_rightPressed 0x36
#define ATMO_EmbeddedPageController_TRIGGER_triggered 0x37
#define ATMO_EmbeddedPageController_TRIGGER_navigateUp 0x38
#define ATMO_EmbeddedPageController_TRIGGER_navigateDown 0x39
#define ATMO_EmbeddedPageController_TRIGGER_navigateLeft 0x3a
#define ATMO_EmbeddedPageController_TRIGGER_navigateRight 0x3b
#define ATMO_EmbeddedPageController_TRIGGER_processTopRightButton 0x3c
#define ATMO_EmbeddedPageController_TRIGGER_processBottomRightButton 0x3d
#define ATMO_EmbeddedPageController_TRIGGER_processTopLeftButton 0x3e
#define ATMO_EmbeddedPageController_TRIGGER_processBottomLeftButton 0x3f
#define ATMO_GetTempStr_TRIGGER_triggered 0x40
#define ATMO_GetLightStr_TRIGGER_triggered 0x41
#define ATMO_GetPressureStr_TRIGGER_triggered 0x42
#define ATMO_GetAirQualityStr_TRIGGER_triggered 0x43
#define ATMO_Humid_Pg_TRIGGER_triggered 0x44
#define ATMO_Humid_Pg_TRIGGER_onDisplayed 0x45
#define ATMO_Humid_Pg_TRIGGER_topRightButtonPressed 0x46
#define ATMO_Humid_Pg_TRIGGER_bottomRightButtonPressed 0x47
#define ATMO_Humid_Pg_TRIGGER_topLeftButtonPressed 0x48
#define ATMO_Humid_Pg_TRIGGER_bottomLeftButtonPressed 0x49
#define ATMO_Humid_Pg_TRIGGER_onLeave 0x4a
#define ATMO_Light_Pg_TRIGGER_triggered 0x4b
#define ATMO_Light_Pg_TRIGGER_onDisplayed 0x4c
#define ATMO_Light_Pg_TRIGGER_topRightButtonPressed 0x4d
#define ATMO_Light_Pg_TRIGGER_bottomRightButtonPressed 0x4e
#define ATMO_Light_Pg_TRIGGER_topLeftButtonPressed 0x4f
#define ATMO_Light_Pg_TRIGGER_bottomLeftButtonPressed 0x50
#define ATMO_Light_Pg_TRIGGER_onLeave 0x51
#define ATMO_Pressure_Pg_TRIGGER_triggered 0x52
#define ATMO_Pressure_Pg_TRIGGER_onDisplayed 0x53
#define ATMO_Pressure_Pg_TRIGGER_topRightButtonPressed 0x54
#define ATMO_Pressure_Pg_TRIGGER_bottomRightButtonPressed 0x55
#define ATMO_Pressure_Pg_TRIGGER_topLeftButtonPressed 0x56
#define ATMO_Pressure_Pg_TRIGGER_bottomLeftButtonPressed 0x57
#define ATMO_Pressure_Pg_TRIGGER_onLeave 0x58
#define ATMO_VOC_pg_TRIGGER_triggered 0x59
#define ATMO_VOC_pg_TRIGGER_onDisplayed 0x5a
#define ATMO_VOC_pg_TRIGGER_topRightButtonPressed 0x5b
#define ATMO_VOC_pg_TRIGGER_bottomRightButtonPressed 0x5c
#define ATMO_VOC_pg_TRIGGER_topLeftButtonPressed 0x5d
#define ATMO_VOC_pg_TRIGGER_bottomLeftButtonPressed 0x5e
#define ATMO_VOC_pg_TRIGGER_onLeave 0x5f
#define ATMO_GetHumidStr_TRIGGER_triggered 0x60
#define ATMO_ENS210TemperatureHumidity_TRIGGER_triggered 0x61
#define ATMO_ENS210TemperatureHumidity_TRIGGER_temperatureRead 0x62
#define ATMO_ENS210TemperatureHumidity_TRIGGER_humidityRead 0x63
#define ATMO_BLEConnection_TRIGGER_triggered 0x64
#define ATMO_BLEConnection_TRIGGER_connected 0x65
#define ATMO_BLEConnection_TRIGGER_disconnected 0x66
#define ATMO_BLEConnection_TRIGGER_pairingRequested 0x67
#define ATMO_BLEConnection_TRIGGER_pairingSucceeded 0x68
#define ATMO_BLEConnection_TRIGGER_pairingFailed 0x69
#define ATMO_PairingSuccess_TRIGGER_triggered 0x6a
#define ATMO_PairingSuccess_TRIGGER_onDisplayed 0x6b
#define ATMO_PairingSuccess_TRIGGER_topRightButtonPressed 0x6c
#define ATMO_PairingSuccess_TRIGGER_bottomRightButtonPressed 0x6d
#define ATMO_PairingSuccess_TRIGGER_topLeftButtonPressed 0x6e
#define ATMO_PairingSuccess_TRIGGER_bottomLeftButtonPressed 0x6f
#define ATMO_PairingSuccess_TRIGGER_onLeave 0x70
#define ATMO_PairingFail_TRIGGER_triggered 0x71
#define ATMO_PairingFail_TRIGGER_onDisplayed 0x72
#define ATMO_PairingFail_TRIGGER_topRightButtonPressed 0x73
#define ATMO_PairingFail_TRIGGER_bottomRightButtonPressed 0x74
#define ATMO_PairingFail_TRIGGER_topLeftButtonPressed 0x75
#define ATMO_PairingFail_TRIGGER_bottomLeftButtonPressed 0x76
#define ATMO_PairingFail_TRIGGER_onLeave 0x77
#define ATMO_PairingCode_TRIGGER_triggered 0x78
#define ATMO_PairingCode_TRIGGER_onDisplayed 0x79
#define ATMO_PairingCode_TRIGGER_topRightButtonPressed 0x7a
#define ATMO_PairingCode_TRIGGER_bottomRightButtonPressed 0x7b
#define ATMO_PairingCode_TRIGGER_topLeftButtonPressed 0x7c
#define ATMO_PairingCode_TRIGGER_bottomLeftButtonPressed 0x7d
#define ATMO_PairingCode_TRIGGER_onLeave 0x7e
#define ATMO_BLECharacteristicCustom_TRIGGER_triggered 0x7f
#define ATMO_BLECharacteristicCustom_TRIGGER_written 0x80
#define ATMO_BLECharacteristicCustom_TRIGGER_subscibed 0x81
#define ATMO_BLECharacteristicCustom_TRIGGER_unsubscribed 0x82
#define ATMO_Variable_TRIGGER_triggered 0x83
#define ATMO_Variable_TRIGGER_valueSet 0x84
#define ATMO_Variable_TRIGGER_valueRetrieved 0x85
#define ATMO_CO2_TRIGGER_triggered 0x86
#define ATMO_CO2_TRIGGER_written 0x87
#define ATMO_CO2_TRIGGER_subscibed 0x88
#define ATMO_CO2_TRIGGER_unsubscribed 0x89
#define ATMO_Co2_pg_TRIGGER_triggered 0x8a
#define ATMO_Co2_pg_TRIGGER_onDisplayed 0x8b
#define ATMO_Co2_pg_TRIGGER_topRightButtonPressed 0x8c
#define ATMO_Co2_pg_TRIGGER_bottomRightButtonPressed 0x8d
#define ATMO_Co2_pg_TRIGGER_topLeftButtonPressed 0x8e
#define ATMO_Co2_pg_TRIGGER_bottomLeftButtonPressed 0x8f
#define ATMO_Co2_pg_TRIGGER_onLeave 0x90
#define ATMO_GetAirQualityStr_CO2_TRIGGER_triggered 0x91
#define ATMO_Temperature_pg_TRIGGER_triggered 0x92
#define ATMO_Temperature_pg_TRIGGER_onDisplayed 0x93
#define ATMO_Temperature_pg_TRIGGER_topRightButtonPressed 0x94
#define ATMO_Temperature_pg_TRIGGER_bottomRightButtonPressed 0x95
#define ATMO_Temperature_pg_TRIGGER_topLeftButtonPressed 0x96
#define ATMO_Temperature_pg_TRIGGER_bottomLeftButtonPressed 0x97
#define ATMO_Temperature_pg_TRIGGER_onLeave 0x98
#ifdef __cplusplus
}
#endif
#endif
